Lucene++ - a full-featured, c++ search engine
API Documentation

Public Member Functions | Static Public Member Functions | Data Fields | Protected Attributes
Lucene::RAMDirectory Class Reference

A memory-resident Directory implementation. Locking implementation is by default the SingleInstanceLockFactory but can be changed with setLockFactory. Lock acquisition sequence: RAMDirectory, then RAMFile. More...

`#include <RAMDirectory.h>`

Inheritance diagram for Lucene::RAMDirectory:

## Public Member Functions

| RAMDirectory ()
| Constructs an empty Directory. More...
| RAMDirectory (const DirectoryPtr &dir)
| Creates a new RAMDirectory instance from a different Directory implementation. This can be used to load a disk-based index into memory. More...
| RAMDirectory (const DirectoryPtr &dir, bool closeDir)
virtual | ~RAMDirectory ()
virtual String | getClassName ()
boost::shared_ptr< RAMDirectory > | shared_from_this ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual HashSet< String > | listAll ()
| Returns an array of strings, one for each file in the directory. More...
virtual bool | fileExists (const String &name)
| Returns true if a file with the given name exists. More...
virtual uint64_t | fileModified (const String &name)
| Returns the time the named file was last modified. More...
virtual void | touchFile (const String &name)
| Set the modified time of an existing file to now. More...
virtual int64_t | fileLength (const String &name)
| Returns the length of a file in the directory. More...
int64_t | sizeInBytes ()
| Return total size in bytes of all files in this directory. This is currently quantized to RAMOutputStream::BUFFER_SIZE. More...
virtual void | deleteFile (const String &name)
| Removes an existing file in the directory. More...
virtual IndexOutputPtr | createOutput (const String &name)
| Creates a new, empty file in the directory with the given name. Returns a stream writing this file. More...
virtual IndexInputPtr | openInput (const String &name)
| Returns a stream reading an existing file. More...
virtual void | close ()
| Closes the store. More...
Public Member Functions inherited from Lucene::Directory
| Directory ()
virtual | ~Directory ()
boost::shared_ptr< Directory > | shared_from_this ()
virtual void | sync (const String &name)
| Ensure that any writes to this file are moved to stable storage. Lucene uses this to properly commit changes to the index, to prevent a machine/OS crash from corrupting the index. More...
virtual IndexInputPtr | openInput (const String &name, int32_t bufferSize)
| Returns a stream reading an existing file, with the specified read buffer size. The particular Directory implementation may ignore the buffer size. Currently the only Directory implementations that respect this parameter are FSDirectory and CompoundFileReader. More...
virtual LockPtr | makeLock (const String &name)
| Construct a Lock. More...
void | clearLock (const String &name)
| Attempt to clear (forcefully unlock and remove) the specified lock. Only call this at a time when you are certain this lock is no longer in use. More...
void | setLockFactory (const LockFactoryPtr &lockFactory)
| Set the LockFactory that this Directory instance should use for its locking implementation. Each * instance of LockFactory should only be used for one directory (ie, do not share a single instance across multiple Directories). More...
LockFactoryPtr | getLockFactory ()
| Get the LockFactory that this Directory instance is using for its locking implementation. Note that this may be null for Directory implementations that provide their own locking implementation. More...
virtual String | getLockID ()
| Return a string identifier that uniquely differentiates this Directory instance from other Directory instances. This ID should be the same if two Directory instances are considered "the same index". This is how locking "scopes" to the right index. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::Directory
static String | _getClassName ()
static void | copy (const DirectoryPtr &src, const DirectoryPtr &dest, bool closeDirSrc)
| Copy contents of a directory src to a directory dest. If a file in src already exists in dest then the one in dest will be blindly overwritten. NOTE: the source directory cannot change while this method is running. Otherwise the results are undefined. More...

## Data Fields

INTERNAL | __pad0__: int64_t _sizeInBytes
MapStringRAMFile | fileMap

## Protected Attributes

DirectoryWeakPtr | _dirSource
bool | copyDirectory
bool | closeDir
Protected Attributes inherited from Lucene::Directory
bool | isOpen
LockFactoryPtr | lockFactory
| Holds the LockFactory instance (implements locking for this Directory instance). More...
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Protected Member Functions inherited from Lucene::Directory
void | ensureOpen ()
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Detailed Description

A memory-resident Directory implementation. Locking implementation is by default the SingleInstanceLockFactory but can be changed with setLockFactory. Lock acquisition sequence: RAMDirectory, then RAMFile.

## Constructor & Destructor Documentation

## ◆ RAMDirectory() [1/3]

Lucene::RAMDirectory::RAMDirectory | ( |  | ) |

Constructs an empty Directory.

## ◆ RAMDirectory() [2/3]

Lucene::RAMDirectory::RAMDirectory | ( | const DirectoryPtr & | dir | ) |

Creates a new RAMDirectory instance from a different Directory implementation. This can be used to load a disk-based index into memory.

This should be used only with indices that can fit into memory.

Note that the resulting RAMDirectory instance is fully independent from the original Directory (it is a complete copy). Any subsequent changes to the original Directory will not be visible in the RAMDirectory instance.

Parameters

  dir | a Directory value

## ◆ RAMDirectory() [3/3]

Lucene::RAMDirectory::RAMDirectory | ( | const DirectoryPtr & | dir,
|  | bool | closeDir
| ) |  |

## ◆ ~RAMDirectory()

virtual Lucene::RAMDirectory::~RAMDirectory | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::RAMDirectory::_getClassName | ( |  | ) |

inline static

## ◆ close()

virtual void Lucene::RAMDirectory::close | ( |  | ) |

virtual

Closes the store.

Implements Lucene::Directory.

## ◆ createOutput()

virtual IndexOutputPtr Lucene::RAMDirectory::createOutput | ( | const String & | name | ) |

virtual

Creates a new, empty file in the directory with the given name. Returns a stream writing this file.

Implements Lucene::Directory.

## ◆ deleteFile()

virtual void Lucene::RAMDirectory::deleteFile | ( | const String & | name | ) |

virtual

Removes an existing file in the directory.

Implements Lucene::Directory.

## ◆ fileExists()

virtual bool Lucene::RAMDirectory::fileExists | ( | const String & | name | ) |

virtual

Returns true if a file with the given name exists.

Implements Lucene::Directory.

## ◆ fileLength()

virtual int64_t Lucene::RAMDirectory::fileLength | ( | const String & | name | ) |

virtual

Returns the length of a file in the directory.

Implements Lucene::Directory.

## ◆ fileModified()

virtual uint64_t Lucene::RAMDirectory::fileModified | ( | const String & | name | ) |

virtual

Returns the time the named file was last modified.

Implements Lucene::Directory.

## ◆ getClassName()

virtual String Lucene::RAMDirectory::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::Directory.

## ◆ initialize()

virtual void Lucene::RAMDirectory::initialize | ( |  | ) |

virtual

Called directly after instantiation to create objects that depend on this object being fully constructed.

Reimplemented from Lucene::LuceneObject.

## ◆ listAll()

virtual HashSet<String> Lucene::RAMDirectory::listAll | ( |  | ) |

virtual

Returns an array of strings, one for each file in the directory.

Implements Lucene::Directory.

## ◆ openInput()

virtual IndexInputPtr Lucene::RAMDirectory::openInput | ( | const String & | name | ) |

virtual

Returns a stream reading an existing file.

Implements Lucene::Directory.

## ◆ shared_from_this()

boost::shared_ptr< RAMDirectory > Lucene::RAMDirectory::shared_from_this | ( |  | ) |

inline

## ◆ sizeInBytes()

int64_t Lucene::RAMDirectory::sizeInBytes | ( |  | ) |

Return total size in bytes of all files in this directory. This is currently quantized to RAMOutputStream::BUFFER_SIZE.

## ◆ touchFile()

virtual void Lucene::RAMDirectory::touchFile | ( | const String & | name | ) |

virtual

Set the modified time of an existing file to now.

Implements Lucene::Directory.

## Field Documentation

## ◆ __pad0__

INTERNAL Lucene::RAMDirectory::__pad0__

## ◆ _dirSource

DirectoryWeakPtr Lucene::RAMDirectory::_dirSource

protected

## ◆ closeDir

bool Lucene::RAMDirectory::closeDir

protected

## ◆ copyDirectory

bool Lucene::RAMDirectory::copyDirectory

protected

## ◆ fileMap

MapStringRAMFile Lucene::RAMDirectory::fileMap

The documentation for this class was generated from the following file:

- RAMDirectory.h

clucene.sourceforge.net